'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.toSet = exports.toArray = undefined;

var _isType = require('./isType');

var _bindable = require('./bindable');

var _bindable2 = _interopRequireDefault(_bindable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const toArray = exports.toArray = (0, _bindable2.default)(function toArray(obj) {
    if (obj === null || obj === undefined) {
        return [];
    }
    if (Array.isArray(obj)) {
        return obj;
    }
    if ((0, _isType.isString)(obj)) {
        return [obj];
    }
    if ((0, _isType.isFunction)(obj[Symbol.iterator])) {
        return [...obj];
    }
    return [obj];
});

const toSet = exports.toSet = (0, _bindable2.default)(function toSet(obj) {
    if (obj instanceof Set) {
        return obj;
    }
    return new Set(toArray(obj));
});