'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = fmap;
const { reduce } = Array.prototype;

const __skip__ = exports.__skip__ = Symbol('skip');

/**
 * Filter-map. Like map, but you may omit entries by returning `__skip__`.
 *
 * @param callback
 */
function fmap(callback) {
    return reduce.call(this, (accum, ...args) => {
        let x = callback.call(this, ...args);
        // TODO: if `x` is a Promise, should we wait for it to resolve? maybe have an async version?
        if (x !== __skip__) {
            accum.push(x);
        }
        return accum;
    }, []);
}