'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.pairsToObject = exports.omit = exports.mapEntries = exports.entries = undefined;
exports.mergeDeep = mergeDeep;
exports.getMethods = getMethods;

var _isType = require('./isType');

var _bindable = require('./bindable');

var _bindable2 = _interopRequireDefault(_bindable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const entries = exports.entries = (0, _bindable2.default)(Object.entries);

const mapEntries = exports.mapEntries = (0, _bindable2.default)((obj, callback) => Reflect.ownKeys(obj).map(k => callback(k, obj[k])));

const omit = exports.omit = (0, _bindable2.default)(function omit(obj, keys) {
    var _context;

    keys = (_context = keys, toSet).call(_context);
    return Object.keys(obj).reduce((acc, k) => {
        if (!keys.has(k)) {
            acc[k] = obj[k];
        }
        return acc;
    }, Object.create(null));
});

const pairsToObject = exports.pairsToObject = (0, _bindable2.default)(array => {
    let result = Object.create(null);
    for (let [k, v] of array) {
        result[k] = v;
    }
    return result;
});

// /**
//  * 
//  * @param {Array} array
//  * @param {Function} callback
//  * @returns {Object}
//  */
// export function mapToObject(array, callback) {
//     let result = Object.create(null);
//     for(let i = 0; i<array.length; ++i) {
//         let pair = callback(array[i], i);
//         result[pair[0]] = pair[1];
//     }
//     return result;
// }

function mergeDeep(target, ...sources) {
    if (!sources.length) return target;
    const source = sources.shift();

    if (Array.isArray(target)) {
        if (Array.isArray(source)) {
            target.push(...source);
        } else {
            target.push(source);
        }
    } else if ((0, _isType.isPlainObject)(target)) {
        if ((0, _isType.isPlainObject)(source)) {
            for (let key of Object.keys(source)) {
                if (!target[key]) {
                    target[key] = source[key];
                } else {
                    mergeDeep(target[key], source[key]);
                }
            }
        } else {
            throw new Error(`Cannot merge object with non-object`);
        }
    } else {
        target = source;
    }

    return mergeDeep(target, ...sources);
}

function getMethods(obj) {
    return Reflect.ownKeys(obj).filter(k => (0, _isType.isFunction)(obj[k]));
}