var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MAP = Symbol('Entries');

var DeepMap = function () {
    function DeepMap() {
        _classCallCheck(this, DeepMap);

        this[MAP] = new WeakMap();
    }

    /**
     * @param {Array.<*>} key
     * @param {*} value
     * @return {void}
     */


    _createClass(DeepMap, [{
        key: 'set',
        value: function set(key, value) {
            var end = key.length - 1;
            var map = this[MAP];
            for (var i = 0; i < end; ++i) {
                if (map.has(key[i])) {
                    map = map.get(key[i]);
                } else {
                    map.set(key[i], map = new Map());
                }
            }
            map.set(key[end], value);
        }

        /**
         * @param {Array.<*>} key
         * @param {*=} defaultValue
         * @return {*}
         */

    }, {
        key: 'get',
        value: function get(key, defaultValue) {
            var value = this[MAP];
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = key[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var k = _step.value;

                    if (!value.has(k)) return defaultValue;
                    value = value.get(k);
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return value;
        }

        /**
         * @param {Array.<*>} key
         * @return {void}
         */

    }, {
        key: 'delete',
        value: function _delete(key) {
            var end = key.length - 1;
            var map = this[MAP];
            for (var i = 0; i < end; ++i) {
                map = map.get(key[i]);
                if (!map) return;
            }
            map.delete(key[end]);
        }
    }]);

    return DeepMap;
}();

export default DeepMap;