function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import { isFunction, isString } from './isType';
import bindable from './bindable';

export var toArray = bindable(function toArray(obj) {
    if (obj === null || obj === undefined) {
        return [];
    }
    if (Array.isArray(obj)) {
        return obj;
    }
    if (isString(obj)) {
        return [obj];
    }
    if (isFunction(obj[Symbol.iterator])) {
        return [].concat(_toConsumableArray(obj));
    }
    return [obj];
});

export var toSet = bindable(function toSet(obj) {
    if (obj instanceof Set) {
        return obj;
    }
    return new Set(toArray(obj));
});