var reduce = Array.prototype.reduce;


export var __skip__ = Symbol('skip');

/**
 * Filter-map. Like map, but you may omit entries by returning `__skip__`.
 *
 * @param callback
 */
export default function fmap(callback) {
    var _this = this;

    return reduce.call(this, function (accum) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
            args[_key - 1] = arguments[_key];
        }

        var x = callback.call.apply(callback, [_this].concat(args));
        // TODO: if `x` is a Promise, should we wait for it to resolve? maybe have an async version?
        if (x !== __skip__) {
            accum.push(x);
        }
        return accum;
    }, []);
}