export default function memoize(fn) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
        serialize: fn.length === 1 ? function (x) {
            return x;
        } : function () {
            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            return JSON.stringify(args);
        } };

    var cache = new Map();
    return function () {
        var key = options.serialize.apply(options, arguments);
        if (cache.has(key)) {
            return cache.get(key);
        }
        var value = fn.apply(undefined, arguments);
        cache.set(key, value);
        return value;
    };
}