var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import { isFunction, isString, isPlainObject } from './isType';
import bindable from './bindable';

export var entries = bindable(Object.entries);

export var mapEntries = bindable(function (obj, callback) {
    return Reflect.ownKeys(obj).map(function (k) {
        return callback(k, obj[k]);
    });
});

export var omit = bindable(function omit(obj, keys) {
    var _context;

    keys = (_context = keys, toSet).call(_context);
    return Object.keys(obj).reduce(function (acc, k) {
        if (!keys.has(k)) {
            acc[k] = obj[k];
        }
        return acc;
    }, Object.create(null));
});

export var pairsToObject = bindable(function (array) {
    var result = Object.create(null);
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = array[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var _ref = _step.value;

            var _ref2 = _slicedToArray(_ref, 2);

            var k = _ref2[0];
            var v = _ref2[1];

            result[k] = v;
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }

    return result;
});

// /**
//  * 
//  * @param {Array} array
//  * @param {Function} callback
//  * @returns {Object}
//  */
// export function mapToObject(array, callback) {
//     let result = Object.create(null);
//     for(let i = 0; i<array.length; ++i) {
//         let pair = callback(array[i], i);
//         result[pair[0]] = pair[1];
//     }
//     return result;
// }

export function mergeDeep(target) {
    for (var _len = arguments.length, sources = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        sources[_key - 1] = arguments[_key];
    }

    if (!sources.length) return target;
    var source = sources.shift();

    if (Array.isArray(target)) {
        if (Array.isArray(source)) {
            var _target;

            (_target = target).push.apply(_target, _toConsumableArray(source));
        } else {
            target.push(source);
        }
    } else if (isPlainObject(target)) {
        if (isPlainObject(source)) {
            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
                for (var _iterator2 = Object.keys(source)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var key = _step2.value;

                    if (!target[key]) {
                        target[key] = source[key];
                    } else {
                        mergeDeep(target[key], source[key]);
                    }
                }
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }
        } else {
            throw new Error('Cannot merge object with non-object');
        }
    } else {
        target = source;
    }

    return mergeDeep.apply(undefined, [target].concat(sources));
}

export function getMethods(obj) {
    return Reflect.ownKeys(obj).filter(function (k) {
        return isFunction(obj[k]);
    });
}