import fmap, { __skip__ } from './fmap';

export function encodeParam(x) {
    if (x === true) {
        return '1';
    }
    if (x === false) {
        return '0';
    }
    if (x === undefined || x === null) {
        return '';
    }
    return encodeURIComponent(x);
}

export function queryParams(params) {
    var _context;

    return (_context = Object.keys(params), fmap).call(_context, function (k) {
        if (params[k] === undefined) {
            return __skip__;
        }
        if (Array.isArray(params[k])) {
            return params[k].map(function (val) {
                return encodeParam(k) + '[]=' + encodeParam(val);
            }).join('&');
        }
        return encodeParam(k) + '=' + encodeParam(params[k]);
    }).join('&');
}

/**
 * Joins URLs together with /. Leaves leading and trailing slashes alone. Does not duplicate internal slashes.
 * 
 * @param {string[]} urls
 * @returns {string}
 */
function joinUrlPaths() {
    for (var _len = arguments.length, urls = Array(_len), _key = 0; _key < _len; _key++) {
        urls[_key] = arguments[_key];
    }

    return urls.map(function (u, i) {
        if (i > 0) {
            u = u.replace(/^\/+/g, '');
        }
        if (i < urls.length - 1) {
            u = u.replace(/\/+$/g, '');
        }
        return u;
    }).join('/');
}